/***************************************************************************
 *   Copyright (C) 2008 by Oliver Groß                                     *
 *   z.o.gross@gmx.de                                                      *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
#ifndef LIBQCROSS_CCROSSPACKAGEMODEL_H
#define LIBQCROSS_CCROSSPACKAGEMODEL_H

#include <QAbstractItemModel>

namespace libqnono {
	class CCrossPackage;
	
	/**
		@author Oliver Groß <z.o.gross@gmx.de>
	*/
	class CCrossPackageModel : public QAbstractItemModel {
		Q_OBJECT
	public:
		CCrossPackageModel(QObject * parent = 0);
		~CCrossPackageModel();
		
		void setPackage(libqnono::CCrossPackage * package);
		
		virtual QModelIndex index(int row, int column = 0, const QModelIndex & parent = QModelIndex()) const;
		virtual QVariant data(const QModelIndex & index, int role = Qt::DisplayRole) const;
		virtual int rowCount(const QModelIndex & parent = QModelIndex()) const;
		virtual int columnCount(const QModelIndex & parent = QModelIndex()) const;
		virtual QVariant headerData(int section, Qt::Orientation orientation, int role = Qt::DisplayRole) const;
		virtual Qt::ItemFlags flags(const QModelIndex & index) const;
		virtual QModelIndex parent(const QModelIndex & index) const;
		virtual bool hasChildren(const QModelIndex & parent = QModelIndex()) const;
		
		virtual bool setData(const QModelIndex & index, const QVariant & value, int role = Qt::EditRole);
		
		bool appendEmpty(QString name, QSize size, bool fillValue);
		bool appendImage(QString name, QImage image);
		
		virtual bool insertRows(int row, int count, const QModelIndex & parent = QModelIndex());
		virtual bool removeRows(int row, int count, const QModelIndex & parent = QModelIndex());
	protected:
		libqnono::CCrossPackage * m_Package;
	};
}

#endif
