#ifndef LIBQCROSS_CNONOGRAMSOLVER_H
#define LIBQCROSS_CNONOGRAMSOLVER_H

#include <QObject>
#include <QSize>
#include <QList>

namespace libqnono {
	class CNonogram;
	
	class CNonogramSolver : public QObject {
		Q_OBJECT
	public:
		CNonogramSolver(QObject * parent = 0);
		~CNonogramSolver();
		
		void setNonogram(CNonogram * nonogram);
	public slots:
		bool solve();
	signals:
		void markRequested(int x, int y, int type);
	protected:
		enum MarkerType {CMT_UNMARKED = 0, CMT_MARKED = 1, CMT_CROSSED = 2, CMT_NONE = 3};
		
		CNonogram * m_Nonogram;
	};
}

#endif
