/***************************************************************************
 *   Copyright (C) 2008 by Oliver Groß                                     *
 *   z.o.gross@gmx.de                                                      *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
#include "common.h"

QString formatedTime(quint32 seconds, bool showSeconds) {
	quint32 strippedSeconds = seconds % 60;
	quint8 minutes = seconds / 60;
	quint8 hours   = minutes / 60;
	
	QString result;
	
	if (hours) {
		if (hours < 10)
			result += '0';
		result += QString::number(hours);
		result += ':';
	}
	
	minutes %= 60;
	
	if (minutes < 10)
		result += '0';
	result += QString::number(minutes);
	
	if (showSeconds) {
		result += ':';
		if (strippedSeconds < 10)
			result += '0';
		result += QString::number(strippedSeconds);
	}
	return result;
}

QString getHighscoreFileName(QString packageFileName) {
	if (packageFileName.isEmpty())
		return QString();
	
	int tagPosition = packageFileName.lastIndexOf('.');
	
	return ((tagPosition == -1) ? packageFileName : packageFileName.left(tagPosition)) + ".hsc";
}
