//
// C++ Interface: cmainwindow
//
// Author: Oliver Groß <z.o.gross@gmx.de>, (C) 2008
//
// Copyright: See COPYING file that comes with this distribution
//
#ifndef QCROSSEDITCMAINWINDOW_H
#define QCROSSEDITCMAINWINDOW_H

#include <QMainWindow>

class QTreeView;
// class QBitmap;
//class QMenu;

namespace libqnono {
	class CCrossPackage;
}

namespace qcrossedit {
	class CMainWindow : public QMainWindow {
		Q_OBJECT
	public:
		CMainWindow(QWidget * parent = 0);
		~CMainWindow();
	protected:
		QTreeView * m_PicListView;
		
/*		QMenu * m_FileMenu;
		QMenu * m_EditMenu;*/
		
// 		QString m_File;
		bool m_Unsaved;
		
		libqnono::CCrossPackage * m_Package;
		
/*		QBitmap * m_Pics;
		QString * m_PackName;*/
		
		inline void setupUi();
		
		void closeEvent(QCloseEvent * event);
		
		bool promtUnsaved();
	protected slots:
		void fileNew();
		void fileOpen();
		bool fileSave();
		bool fileSaveAs();
		
		void editCreateEmpty();
		void editCreateFromPicture();
		void editRename();
		void editSetTimeout();
		void editDelete();
		void editSetPackageName();
		
		void helpAbout();
	};

}

#endif
